(***********************************************************)
(**  D-Sub 25 LPT Demo Example                                     **)
(***********************************************************)
(**  Created by: Ching-Yuh Huang   seaturn99@yahoo.com.tw **)
(**  Created on: 13/02/2004                               **)
(**                                                       **)
(***********************************************************)
(** Licence:                                              **)
(***********************************************************)
(** iHHNק,Yקεo{ bug ,г· mail @ **)
(***********************************************************)

unit DSub25;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, jpeg, StdCtrls, IEEE1284;

type
  TForm2 = class(TForm)
    Image1: TImage;
    plStatus: TPanel;
    plControl: TPanel;
    Pin17: TShape;
    Pin16: TShape;
    Pin14: TShape;
    plGround: TPanel;
    Pin25: TShape;
    Pin24: TShape;
    Pin23: TShape;
    Pin22: TShape;
    Pin21: TShape;
    Pin20: TShape;
    Pin19: TShape;
    Pin18: TShape;
    Pin15: TShape;
    Edit9: TEdit;
    btnInit: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnRefresh: TButton;
    Pin1: TShape;
    Pin10: TShape;
    Pin11: TShape;
    Pin12: TShape;
    Pin13: TShape;
    plData: TPanel;
    Pin2: TShape;
    Pin3: TShape;
    Pin4: TShape;
    Pin5: TShape;
    Pin6: TShape;
    Pin7: TShape;
    Pin8: TShape;
    Pin9: TShape;
    Edit10: TEdit;
    btnData: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnInitClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure btnDataClick(Sender: TObject);
  private
    { Private declarations }
    FSPPDev: TParallePortDevice;
    function BitSet(PinNum: integer): boolean;
  public
    { Public declarations }
    procedure ShowAllREG;
    procedure ShowPins;
    procedure SendEOT;
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.SendEOT;
begin
  FSPPDev.WriteToCTRL_REG($02);
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  FSPPDev := TParallePortDevice.Create;

  if not FSPPDev.Started then
  begin
    FreeAndNil(FSPPDev);
    raise Exception.Create('Can''''t Init zlioport Driver!!');
  end;

  FSPPDev.SelectLPT('LPT1');
  btnInit.Click;
  btnRefresh.Click;
  // FSPPDev.InitDevive(StrToInt('$'+Edit9.Text));
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FSPPDev);
end;


procedure TForm2.btnInitClick(Sender: TObject);
begin
  FSPPDev.InitDevive(StrToInt('$' + Edit9.Text));
end;

procedure TForm2.ShowAllREG;
begin
  Label1.Caption := 'Data : ' + IntToHex(FSPPDev.RedaFromData_REG, 2);
  Label2.Caption := 'Status : ' + IntToHex(FSPPDev.RedaFromStatus_REG, 2);
  Label3.Caption := 'Control : ' + IntToHex(FSPPDev.RedaFromCTRL_REG, 2);
end;

procedure TForm2.btnRefreshClick(Sender: TObject);
begin
  Edit10.Text := IntToHex(FSPPDev.RedaFromData_REG, 2);
  ShowAllREG;
  ShowPins;
end;

function CheckBit(Data: byte; pos: integer): boolean;
begin
  Result := false;

  if ((Data shr pos) and $01) <> 0 then
    Result := true;
end;

function TForm2.BitSet(PinNum: integer): boolean;
begin
  Result := false;
  // Data Bits
  if PinNum in [2..9] then
  begin
    Result := CheckBit(FSPPDev.RedaFromData_REG, PinNum - 2);
  end
    // Ststus Bits
  else if (PinNum in [10..13, 15]) then
  begin
    if PinNum = 15 then
      Result := CheckBit(FSPPDev.RedaFromStatus_REG, 3)
    else if PinNum = 10 then
      Result := CheckBit(FSPPDev.RedaFromStatus_REG, 6)
    else if PinNum = 11 then
      Result := CheckBit(FSPPDev.RedaFromStatus_REG, 7)
    else if PinNum = 12 then
      Result := CheckBit(FSPPDev.RedaFromStatus_REG, 5)
    else if PinNum = 13 then
      Result := CheckBit(FSPPDev.RedaFromStatus_REG, 4);
   end
   // Control Bits
   else if PinNum in [1, 14, 16, 17] then
   begin
    if PinNum = 1 then
      Result := CheckBit(FSPPDev.RedaFromCTRL_REG, 0)
    else if PinNum = 14 then
      Result := CheckBit(FSPPDev.RedaFromCTRL_REG, 1)
    else if PinNum = 16 then
      Result := CheckBit(FSPPDev.RedaFromCTRL_REG, 2)
    else if PinNum = 17 then
      Result := CheckBit(FSPPDev.RedaFromCTRL_REG, 3);
   end
   // Ground
   else if PinNum in [18..25] then
     Result := false;
   end;

procedure TForm2.ShowPins;
var
  i: Integer;
  shape: TShape;
begin

  for i := 0 to plStatus.ControlCount - 1 do
    if plStatus.Controls[i].ClassType = TShape then
    begin
      shape := TShape(plStatus.Controls[i]);
      
      if BitSet(shape.Tag) then
        shape.Brush.Color := clRed
      else
        shape.Brush.Color := clWhite;
    end;

  for i := 0 to plControl.ControlCount - 1 do
    if plControl.Controls[i].ClassType = TShape then
    begin
      shape := TShape(plControl.Controls[i]);
      
      if BitSet(shape.Tag) then
        shape.Brush.Color := clRed
      else
        shape.Brush.Color := clWhite;
    end;

  for i := 0 to plData.ControlCount - 1 do
    if plData.Controls[i].ClassType = TShape then
    begin
      shape := TShape(plData.Controls[i]);

      if BitSet(shape.Tag) then
        shape.Brush.Color := clRed
      else
        shape.Brush.Color := clWhite;
    end;

  for i := 0 to plGround.ControlCount - 1 do
    if plGround.Controls[i].ClassType = TShape then
    begin
      shape := TShape(plGround.Controls[i]);
      
      if BitSet(shape.Tag) then
        shape.Brush.Color := clRed
      else
        shape.Brush.Color := clWhite;
    end;

end;

procedure TForm2.btnDataClick(Sender: TObject);
begin
  FSPPDev.WriteToData_REG(StrToInt('$' + Edit10.Text));
  btnRefresh.Click;
end;

end.

